package net.rzdata.demo.dict.domain;

import lombok.Getter;
import lombok.Setter;
import lombok.ToString;
import net.rzdata.trait.IConverter;
import net.rzdata.trait.IQuery;
import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.mapstruct.factory.Mappers;

@Getter
@Setter
@ToString
public class UpdateDictReq implements IQuery<Dict> {

    /**
     * 字典ID
     */
    private String id;
    /**
     * 字典标签
     */
    private String label;
    /**
     * 字典值
     */
    private String value;
    /**
     * 排序
     */
    private Integer sort;
    /**
     * 父级ID
     */
    private String parentId;
    /**
     * 是否禁用
     */
    private Boolean disabled;

    public Dict into() {
        return UpdateDictReqConverter.INSTANCE.convert(this);
    }
}

@Mapper
interface UpdateDictReqConverter extends IConverter<UpdateDictReq, Dict> {

    UpdateDictReqConverter INSTANCE = Mappers.getMapper(UpdateDictReqConverter.class);

    @Mapping(target = "type", ignore = true)
    @Mapping(target = "children", ignore = true)
    @Override
    Dict convert(UpdateDictReq req);
}
